import { BioEntitiesAccordion } from '@/components/Map/Drawer/SearchDrawerWrapper/GroupedSearchResults/BioEntitiesAccordion';
import { DrugsAccordion } from '@/components/Map/Drawer/SearchDrawerWrapper/GroupedSearchResults/DrugsAccordion';
import { ChemicalsAccordion } from '@/components/Map/Drawer/SearchDrawerWrapper/GroupedSearchResults/ChemicalsAccordion';
import { MirnaAccordion } from '@/components/Map/Drawer/SearchDrawerWrapper/GroupedSearchResults/MirnaAccordion';
import { Accordion } from '@/shared/Accordion';
import { useAppSelector } from '@/redux/hooks/useAppSelector';
import { searchValueSelector } from '@/redux/search/search.selectors';

export const CLOSE_BUTTON_ROLE = 'close-drawer-button';

export const GroupedSearchResults = (): JSX.Element => {
  const searchValue = useAppSelector(searchValueSelector);

  return (
    <div className="flex flex-col" data-testid="grouped-search-results">
      <div className="flex items-center justify-between border-b border-b-divide px-6">
        <div className=" py-8 text-xl">
          <span className="font-normal">Search: </span>
          <span className="font-semibold">{searchValue}</span>
        </div>
      </div>
      <div className="px-6">
        <Accordion allowZeroExpanded>
          <BioEntitiesAccordion />
          <DrugsAccordion />
          <ChemicalsAccordion />
          <MirnaAccordion />
        </Accordion>
      </div>
    </div>
  );
};
