import { FIRST, SIZE_OF_EMPTY_ARRAY } from '@/constants/common';
import { bioEntityResponseFixture } from '@/models/fixtures/bioEntityContentsFixture';
import { ELEMENT_SEARCH_RESULT_MOCK_ALIAS } from '@/models/mocks/elementSearchResultMock';
import { apiPath } from '@/redux/apiPath';
import { mockNetworkResponse } from '@/utils/mockNetworkResponse';
import { getReduxStoreWithActionsListener } from '@/utils/testing/getReduxStoreActionsListener';
import { waitFor } from '@testing-library/react';
import { HttpStatusCode } from 'axios';
import { handleAliasResults } from './handleAliasResults';

const mockedAxiosOldClient = mockNetworkResponse();

describe('handleAliasResults - util', () => {
  const { store } = getReduxStoreWithActionsListener();
  const { dispatch } = store;

  mockedAxiosOldClient
    .onGet(
      apiPath.getBioEntityContentsStringWithQuery({
        searchQuery: ELEMENT_SEARCH_RESULT_MOCK_ALIAS.id.toString(),
        isPerfectMatch: true,
      }),
    )
    .reply(HttpStatusCode.Ok, bioEntityResponseFixture);

  beforeAll(async () => {
    handleAliasResults(dispatch)(ELEMENT_SEARCH_RESULT_MOCK_ALIAS);
  });

  it('should run getBioEntityAction', async () => {
    await waitFor(() => {
      const actions = store.getActions();
      expect(actions.length).toBeGreaterThan(SIZE_OF_EMPTY_ARRAY);
      expect(actions[FIRST].type).toEqual('project/getMultiBioEntity/pending');
    });
  });
});
