import {
  ELEMENT_SEARCH_RESULT_MOCK_ALIAS,
  ELEMENT_SEARCH_RESULT_MOCK_REACTION,
} from '@/models/mocks/elementSearchResultMock';
import * as handleAliasResults from './handleAliasResults';
import * as handleReactionResults from './handleReactionResults';
import { handleSearchResultAction } from './handleSearchResultAction';

jest.mock('./handleAliasResults', () => ({
  __esModule: true,
  handleAliasResults: jest.fn().mockImplementation(() => (): null => null),
}));

jest.mock('./handleReactionResults', () => ({
  __esModule: true,
  handleReactionResults: jest.fn().mockImplementation(() => (): null => null),
}));

const handleAliasResultsSpy = jest.spyOn(handleAliasResults, 'handleAliasResults');
const handleReactionResultsSpy = jest.spyOn(handleReactionResults, 'handleReactionResults');

describe('handleSearchResultAction - util', () => {
  const dispatch = jest.fn();

  beforeEach(() => {
    jest.clearAllMocks();
  });

  describe('on ALIAS search results', () => {
    const searchResults = [ELEMENT_SEARCH_RESULT_MOCK_ALIAS];

    it('should fire handleAliasResults', async () => {
      await handleSearchResultAction({ searchResults, dispatch });
      expect(handleAliasResultsSpy).toBeCalled();
    });
  });

  describe('on REACTION search results', () => {
    const searchResults = [ELEMENT_SEARCH_RESULT_MOCK_REACTION];

    it('should fire handleReactionResults', async () => {
      await handleSearchResultAction({ searchResults, dispatch });
      expect(handleReactionResultsSpy).toBeCalled();
    });
  });
});
