import { FIRST } from '@/constants/common';
import { AppDispatch } from '@/redux/store';
import { ElementSearchResult } from '@/types/models';
import { handleAliasResults } from './handleAliasResults';
import { handleReactionResults } from './handleReactionResults';

interface HandleSearchResultActionInput {
  searchResults: ElementSearchResult[];
  dispatch: AppDispatch;
}

export const handleSearchResultAction = async ({
  searchResults,
  dispatch,
}: HandleSearchResultActionInput): Promise<void> => {
  const closestSearchResult = searchResults[FIRST];
  const { type } = closestSearchResult;
  const action = {
    ALIAS: handleAliasResults,
    REACTION: handleReactionResults,
  }[type];

  await action(dispatch)(closestSearchResult);
};
