import { SIZE_OF_EMPTY_ARRAY } from '@/constants/common';
import { rootSelector } from '@/redux/root/root.selectors';
import { createSelector } from '@reduxjs/toolkit';
import { MultiSearchData } from '@/types/fetchDataState';
import { Mirna } from '@/types/models';
import { currentSelectedSearchElement } from '../drawer/drawer.selectors';

export const mirnasSelector = createSelector(rootSelector, state => state.mirnas);

export const mirnasForSelectedSearchElementSelector = createSelector(
  mirnasSelector,
  currentSelectedSearchElement,
  (mirnasState, currentSearchElement): MultiSearchData<Mirna[]> | undefined =>
    mirnasState.data.find(({ searchQueryElement }) => searchQueryElement === currentSearchElement),
);

export const loadingMirnasStatusSelector = createSelector(mirnasSelector, state => state.loading);

export const numberOfMirnasSelector = createSelector(
  mirnasForSelectedSearchElementSelector,
  state => {
    if (!state || !state?.data) {
      return SIZE_OF_EMPTY_ARRAY;
    }

    return state.data.length && state.data.map(e => e.targets.length)?.reduce((a, b) => a + b);
  },
);
