import { createSlice } from '@reduxjs/toolkit';
import { MirnasState } from '@/redux/mirnas/mirnas.types';
import { getMirnasReducer, getMultiMirnasReducer } from './mirnas.reducers';

const initialState: MirnasState = {
  data: [],
  loading: 'idle',
  error: { name: '', message: '' },
};

export const mirnasSlice = createSlice({
  name: 'mirnas',
  initialState,
  reducers: {},
  extraReducers: builder => {
    getMirnasReducer(builder);
    getMultiMirnasReducer(builder);
  },
});

export default mirnasSlice.reducer;
