import { Reaction } from '@/types/models';
import { createSelector } from '@reduxjs/toolkit';
import { currentDrawerReactionIdSelector } from '../drawer/drawer.selectors';
import { currentModelIdSelector } from '../models/models.selectors';
import { rootSelector } from '../root/root.selectors';

export const reactionsSelector = createSelector(rootSelector, state => state.reactions);

export const reactionsDataSelector = createSelector(
  reactionsSelector,
  reactions => reactions?.data || [],
);

export const allReactionsSelectorOfCurrentMap = createSelector(
  reactionsDataSelector,
  currentModelIdSelector,
  (reactions, currentModelId): Reaction[] => {
    return reactions.filter(({ modelId }) => modelId === currentModelId);
  },
);

export const currentDrawerReactionSelector = createSelector(
  reactionsDataSelector,
  currentDrawerReactionIdSelector,
  (reactions, currentDrawerReactionId) =>
    reactions.find(({ id }) => id === currentDrawerReactionId),
);
